#### Estimate the branch lengths from node to tip

setwd("/Users/junINOUEb/Downloads/nodeTipBL")

library(ape)
trFile       <- read.tree("200_RAxML_bipartitions.outfile")
tr           <- ladderize(trFile)
infileName   <- "210_2ndRes.txt"
infile       <- read.table(infileName, na.strings = FALSE)

outfileName  <- "out_nodeTipBL"



######################
### A function to pick up the information from result file.
#line.picker <- function(lines,keyWord)
#{
#  container <- c()
#  frag <- 0
#  lineStock <- c()
# for(line in lines) {
#    ### Collect lines 
#    if (regexpr('^>', line) < 0) {
#      if(frag == 1) {
#        lineStock <- c(lineStock, line)
#      }
#    }
#   if (regexpr('^>', line) > 0)
#   {
#      if(frag == 1)
#      {
#        container <- c(container, lineStock)
#        lineStock <- c()
#        break
#      }
#
#      keyWord1 <- paste('>',keyWord,sep='')
#      if (regexpr(keyWord1, line) > 0)
#      {
#        container <- c(container, line)
#        frag <- 1
#      }
#    }
#  }
#  container <- c(container, lineStock)    
#  container <- container[-1]
#  return(container)
#}
#
#
### A function to check the presence of absence of subject
#preab.sub <- function (linesA, keyWordA)
#{
#  if(any(i <- grep(keyWordA,infile$V1)))
#  {
#    containerA <- line.picker(linesA,keyWordA)
#  } else {
#    print (paste(keyWordA,' does not exist.', sep=''))
#    containerA  <- NULL
#  }
#  return(containerA)
#}


### Pick up the information form the result file
#humanTopHit       <- preab.sub(infile$V1,"humanTopHit") 
humanTopHit        <- "Human_ENSP00000319814_PCK1_100"

#fishLeaves        <- preab.sub(infile$V1,"FishNode") 
#tetLeaves         <- preab.sub(infile$V1,"TetraNode") 
fishLeaves         <- c("Zebrafish_ENSDARP00000018261_pck1_100","Cod_ENSGMOP00000020069_PCK1_98","Medaka_ENSORLP00000016033_PCK1_99","Stickleback_ENSGACP00000004885_PCK1_99","Tetraodon_ENSTNIP00000020630_PCK1_99","Fugu_ENSTRUP00000020541_PCK1_100")
tetLeaves          <- c("Xenopus_ENSXETP00000035200_pck1_100","Chicken_ENSGALP00000012342_F1NKP4CHICK_100","Human_ENSP00000319814_PCK1_100")

#####################


## Calculate distance from hfMRCA to each fish/tet tip
fishHights <- c()
tetHights  <- c()
for(z in 1:length(tr$tip.label)) {
  ## Fishes
  for (fish in fishLeaves) {
    if(tr$tip.label[z] == fish){
      HFmrca     <- mrca(tr)[humanTopHit,fish]
      fishHight  <- dist.nodes(tr)[HFmrca, z]
      fishHights <- c(fishHights, fishHight)
      #cat(fish,'\t', fishHight,'\n')
    }
  }
  ## Tetrapods
  for(tet in tetLeaves){
    if(tr$tip.label[z] == tet){
      FHmrca    <- mrca(tr)[fishLeaves[1],tet]
      tetHight  <- dist.nodes(tr)[FHmrca, z]
      tetHights <- c(tetHights, tetHight)       
      #cat(tet,'\t', tetHight,'\n')
    }  	
  }
}
#cat(fish,'\t', fishHights,'\n')
fishMean <- mean(fishHights)
tetMean  <- mean(tetHights)

########## Printout
write('>BLcompHF',  file=outfileName, append=TRUE)
#write('\r',         file=outfileName, append=TRUE)
write(fishMean,         file=outfileName, append=TRUE)
write(tetMean,          file=outfileName, append=TRUE)
write(tetMean/fishMean, file=outfileName, append=TRUE)

#write(tetMean/fishMean, file=infileName, append=TRUE)




#write(DisHumanFish, file=infileName, append=TRUE)



#tr$node.label<-((length(tr$tip)+1):((length(tr$tip)*2)-1))
#plot(tr, show.tip.label=TRUE, show.node.label=TRUE)

